'Slupkowy termometr (dwupunktowy)
'Marcin Wizania

$noramclear
$crystal = 4000000
Config Watchdog = 2048
Stop Watchdog
Config Timer0 = Timer , Prescale = 64
Config 1wire = Portd.6

Config Portb = Output
Config Pind.0 = Output
Config Pind.1 = Output
Config Pind.2 = Output
Config Pind.3 = Output
Config Pind.4 = Output
Config Pind.5 = Output
Config Pind.6 = Input

Declare Sub Ust_cyfr
Declare Sub Odcz_temp
Declare Sub Zap_num
Declare Sub Przelicz
On Timer0 Wyswietl


Dim T(4) As Byte                                            'Tablica przechowujaca dane do wyswietlenia
Dim I As Byte                                               'Zmienna licznikowa wykorzystywana podczas multipleksowania
Dim Id(8) As Byte                                           'Tablica przechowujaca numer seryjny odczytany z DS1820
Dim J As Byte                                               'zmienna ideksujaca tablice
Dim Il_c As Byte                                            'okresla ilosc ukladow DS1820
Dim Temper(2) As Byte                                       'Zmienna wykorzystywana podczas przetwarzania odczytanej temperatura
Dim Dzies As Byte                                           'przechowuje dziesiatki odczytanej temperatury
Dim Jedn As Byte                                            'przechowuje jednosti odczytanej temperatury
Dim Wysw1 As Byte                                           'pomaga podczas multipleksowania w wyborze danych do wyswietlenia
Dim Wysw2 As Byte                                           ' j.w.
Dim Pocz As Byte                                            'zmienna poczatkowa dla petli for
Dim Kon As Byte                                             'zmienna koncowa dla petli for
Dim K As Byte                                               'zmienna pomocnicza dla indeksowania tablic


W1 Alias Portb.4
W2 Alias Portb.5
W3 Alias Portb.6
W4 Alias Portb.7
W5 Alias Portd.0
W6 Alias Portd.1
W7 Alias Portd.5
W8 Alias Portd.4
W9 Alias Portd.3
W10 Alias Portd.2
K1 Alias Portb.0
K2 Alias Portb.1
K3 Alias Portb.2
K4 Alias Portb.3
Jp Alias Pind.6

Portb = 255
Portd = 255
I = 1
T(1) = 10                                                   'zapisanie liczby 10 rownowazne jest wydaszeniu danego wyswietlacza
T(2) = 10
T(3) = 10
T(4) = 10
Wysw1 = 1
Wysw2 = 2
Pocz = 1
Kon = 8

Enable Interrupts
Enable Timer0
Start Timer0
Readeeprom Il_c , 9                                         'odczyt z pamieci liczby dolaczonych ukladow DS1820

If Il_c > 2 Then                                            'jezeli liczba ukladow wieksza od 2 to zeruj zmienna Il_c
  Il_c = 0
End If

If Jp = 0 Then                                              'jezeli zwora jp zwarta wykonywana jest procedura programowania
  If Il_c = 1 Then                                          'Jezeli byl juz zaprogramowany jeden DS1820 to zapiasz odpowiednie
    Wysw1 = 3                                               'dane do zmiennych ktore beda wykorzystane
    Wysw2 = 4                                               'do rejestracji drugiego czujnika DS1820
    Pocz = 10
    Kon = 17
  End If
  T(wysw1) = 4                                              'zapiasz do zmiennych wyswietlacza liczbe ktrora bedzie swiadczyc o przejsciu termometru w tryb rejestracji
  T(wysw2) = 4                                              'czujnikow
  Bitwait Jp , Set                                          'czekaj na zdjecie zworki
  Do                                                        'poczatek petli do-loop
    If Il_c = 2 Then                                        'jezeli zarejestrowane dwa czujniki DS1820 to
      Il_c = 0                                              'zerowanie zmiennej liczby czujnikow
      Writeeeprom Il_c , 9                                  'zapisz do eeprom
      Exit Do                                               'wyjscie z petli do-loop (rownowazne ze skasowaniem numerow dolaczonych czujnikow)
    End If
    T(wysw1) = 4
    T(wysw2) = 4
    Disable Timer0
    1wreset                                                 'odczyt numerow seryjnych z czujnikow
    1wwrite &H33
    For J = 1 To 8
      Id(j) = 1wread()
    Next J
    1wreset
    Enable Timer0
    If Err = 0 Then                                         'jezeli brak bledow w odczycie numeru seryjnego
      K = 1
      For J = Pocz To Kon                                   'to zapis numerow seryjnych do eeprom
        Writeeeprom Id(k) , J
        Incr K
      Next J
      Incr Il_c
      Writeeeprom Il_c , 9                                  'zapis liczby ukladow DS1820
    End If
    Waitms 250
    T(wysw1) = 5
    T(wysw2) = 5
    Waitms 250
  Loop Until Err = 0                                        'Jezeli brak bledow to opuszczana jest petla do-loop
End If

Do                                                          'petla glowna programu
  If Il_c = 0 Then                                          'Jezeli brak ukladow DS1820 to
    T(1) = 0                                                'sygnalizuj odpowiednio zapalaniem wyswietlaczy
    T(2) = 0
    T(3) = 10
    T(4) = 10
    Waitms 250
    T(1) = 10
    T(2) = 10
    T(3) = 0
    T(4) = 0
    Waitms 250
  Else
    If Il_c > 0 Then                                        'Jezeli dolaczonych jest wiecej niz jeden czujnik
      Wysw1 = 1                                             'to zaladuj odpowiednie dane do zmiennych
      Wysw2 = 2
      Pocz = 1
      Kon = 8
      Call Odcz_temp                                        'wywolanie procedury pomiaru temperatury
      Waitms 500
    End If
    If Il_c = 2 Then                                        'Jezeli dolaczone sa dwa czujniki
      Wysw1 = 3                                             'to zaladuj odpowiednie dane do zmiennych
      Wysw2 = 4
      Pocz = 10
      Kon = 17
      Call Odcz_temp                                        'wywolanie rocedury pomiaru temperatury
      Waitms 500
    End If
  End If
Loop
End

Sub Przelicz                                                'Procedura przeliczajaca odczytana temperature na forme potrzebna dla wyswietlacza
  Temper(1) = Temper(1) / 2
  Dzies = Temper(1) / 10
End Sub

Sub Zap_num                                                 'Procedura wyboru odpowiedniego czujnika
  Disable Timer0                                            'poprzez zapisanie wczesniej odczytanych
  1wreset                                                   'numerow seryjnych
  Enable Timer0
  Waitms 5
  Disable Timer0
  1wwrite &H55
  Enable Timer0
  Waitms 5
  For J = 1 To 8
    Disable Timer0
    1wwrite Id(j)
    Enable Timer0
    Waitms 5
  Next J
End Sub

Sub Odcz_temp                                               'Procedura odczytu temperatury
  K = 1
  For J = Pocz To Kon                                       'Odczyt numeru seryjnego z eeprom
    Readeeprom Id(k) , J
    Incr K
  Next J
  Call Zap_num                                              'Wywolanie procedury zapisu numeru seryjnego do DS1820
  Disable Timer0
  1wwrite &H44                                              'Start konwersji
  Enable Timer0
  Waitms 500
  Call Zap_num
  Disable Timer0
  1wwrite &HBE                                              'odczyt zmierzonej temperatury
  Enable Timer0
  Waitms 5
  Disable Timer0
  Temper(1) = 1wread(2)
  Enable Timer0
  Waitms 5
  Disable Timer0
  1wreset
  Enable Timer0
  If Temper(2) = 0 Then                                     'przeliczanie dodatniej odczytanej temperatury
    Call Przelicz                                           'wywolanie procedury przelicz
    Dzies = Dzies + 5
  Else                                                      'przeliczenie ujemnej odczytanej temperatury
    Temper(1) = 256 - Temper(1)                             'wywolanie procedury przelicz
    Call Przelicz
    Dzies = 4 - Dzies
  End If
  Jedn = Temper Mod 10                                      'obliczenie jednostek temperatury
  T(wysw1) = Dzies
  T(wysw2) = Jedn
End Sub

Sub Ust_cyfr                                                'Procedura wyboru punktu do wyswietlenia
  Portb = Portb Or &B11110000                               'zerowanie wyswietlanego punktu
  Portd = Portd Or &B00111111
  Select Case T(i)
    Case 0 :
      Reset W1
    Case 1 :
      Reset W2
    Case 2 :
      Reset W3
    Case 3 :
      Reset W4
    Case 4 :
      Reset W5
    Case 5 :
      Reset W6
    Case 6 :
      Reset W7
    Case 7 :
      Reset W8
    Case 8 :
      Reset W9
    Case 9 :
      Reset W10
  End Select
End Sub

Wyswietl:                                                   'Przerwanie od timer0 realizujace multilpleksowanie wyswietlacza
  Disable Timer0                                            'zablokowanie przerwania
  Set K1                                                    'wylacz wszystkie wyswietlacze
  Set K2
  Set K3
  Set K4
  Call Ust_cyfr                                             'wywolanie procedury wlaczajacej odpowiedni punkt
  Select Case I                                             'W Zaleznosci Od Zmiennej I Zalaczany Jest Odpowiedni Wyswietlacz
    Case 1:
      Reset K1
    Case 2:
      Reset K2
    Case 3:
      Reset K3
    Case 4:
      Reset K4
  End Select
  Incr I                                                    'zwieksz zmienna I
  If I = 5 Then                                             'Jezeli zmienna I=5 to
    I = 1                                                   'zapisz do niej warto 1
  End If
  Enable Timer0                                             'zezwolenie na przerwanie
Return