'Czasowy wycznik TV
'Marcin Wizania

$noramclear
$crystal = 1000000
Config Watchdog = 2048

Config Timer0 = Timer , Prescale = 256
Config Pinb.0 = Output
Config Pinb.1 = Output
Config Pinb.2 = Output
Config Pinb.3 = Input
Config Pinb.4 = Input

On Timer0 Odlicz_sek                                        'Przerwanie od Timer 0

Declare Sub Sygn
Dim T_ms As Byte
Dim Ustaw As Byte
Dim Odl_min As Byte
Dim Odl_czas As Byte
Dim F1 As Bit
Dim F2 As Bit
Dim F3 As Bit
Dim Flaga1 As Bit
Dim Flaga2 As Bit
Dim Dane As Byte
Dim Temp As Byte
Dim I As Byte

Reset Portb.0
Reset Portb.1
Reset Portb.2
Set Portb.3
Set Portb.4
Wait 1

Enable Interrupts
Enable Timer0

T_ms = 0
Ustaw = 0
Flaga1 = 0
Flaga2 = 0
Temp = 0

Readeeprom Dane , 5                                         'Odczyt stanu przekanika zapamietanego uprzednio
If Dane <> 0 Then                                           'w EEPROM
  Set Portb.0
  Set Portb.1
  Set Portb.2
  Ustaw = 5
End If

Do
  If Pinb.3 = 0 Then                                        'Obsluga odbioru sygnalu z pilota podczerwieni
    Do
      For I = 1 To 100
        Waitms 1
        If Pinb.3 = 0 Then
          Incr Temp
          Exit For
        End If
      Next I
      If I > 100 Then
        Temp = 0
        Exit Do
      End If
    Loop Until Temp = 200
    If Temp = 200 Then
      Flaga2 = 1
      Temp = 0
    End If
  End If
  If Pinb.4 = 0 Or Flaga2 = 1 Then                          'Jezeli zostal nadany sygnal z pilota lub
    Flaga2 = 0                                              'nacisniety zostal przycisk to
    Waitms 200                                              'zmien wartosc zmiennej "ustaw"
    Incr Ustaw
    If Ustaw = 6 Then
      Ustaw = 0
      Reset Portb.2
      Reset Portb.0
      Reset Portb.1
      Dane = 0
      Writeeeprom Dane , 5
      Call Sygn
    End If
    Select Case Ustaw
      Case 1 :
        Odl_czas = 15                                       'Ustawienie czasu 15 min
        Set Portb.2                                         'oraz odpowiedniego wyjscia ukladu U2
        Reset Portb.0
        Reset Portb.1
      Case 2 :
        Odl_czas = 30                                       'Ustawienie czasu 30 min
        Reset Portb.2
        Set Portb.0
      Case 3 :
        Odl_czas = 60                                       'Ustawienie czasu 60 min
        Set Portb.2
        Set Portb.0
      Case 4 :
        Odl_czas = 120                                      'Ustawienie czasu 120 min
        Reset Portb.2
        Reset Portb.0
        Set Portb.1
      Case 5 :
        Odl_czas = 180                                      ' 'Ustawienie czasu 180 min
        Set Portb.2
        Set Portb.1
    End Select
    If Ustaw <> 0 Then                                      'Start odliczania czasu
      Odl_min = 0
      Load Timer0 , 220
      Start Timer0
      Flaga1 = 1
    End If
    Bitwait Pinb.4 , Set
    Waitms 100
  End If
  If Odl_czas = 0 And Flaga1 = 1 Then                       'Jezeli czas zostal odliczony to zalacz przekaznik
    Flaga1 = 0
    Stop Timer0
    Set Portb.2
    Set Portb.0
    Set Portb.1
    Dane = 1
    Writeeeprom Dane , 5                                    'Zapamietuje stan przekaznika
    Ustaw = 5
  End If
  If Flaga1 = 1 And Odl_czas = 1 And Odl_min < 5 Then       'Sygnalizacja bliskiego konca odliczania
    F1 = Pinb.2
    F2 = Pinb.0
    F3 = Pinb.1
    Reset Portb.2
    Set Portb.0
    Set Portb.1
    Waitms 200
    Portb.2 = F1
    Portb.0 = F2
    Portb.1 = F3
    Waitms 200
  End If
Loop
End

Sub Sygn                                                    'obsluga sygnalizatora piezo
  Reset Portb.2
  Set Portb.0
  Set Portb.1
  Waitms 500
  Reset Portb.2
  Reset Portb.0
  Reset Portb.1
  Waitms 100
End Sub

Odlicz_sek:                                                 'Obsluga przerwania od timera 0
  Load Timer0 , 220
  Incr T_ms
  If T_ms = 20 Then
    T_ms = 0
    Incr Odl_min
    If Odl_min = 60 Then
      Odl_min = 0
      Decr Odl_czas
    End If
  End If
Return