'Procesor audio na ukadzie BH3874AKS2
'Marcin Wizania
'email: marcin.wiazania@ep.com.pl

'*************************************************************************************
'* Ustawienia bezpiecznikow w BASCOM: (potrzebne do poprawnej pracy mikrokontrolera) *
'* Lockbits - bez zmian                                                              *
'* Fusebits:                                                                         *
'*  - Fusebit C: 0 (BODLEVEL 4.0V)                                                   *
'*  - Fusebit B: 0 (BODEN enabled)                                                   *
'*  - Fusebit KL: 10 (6 CK, 64 mS delay)                                             *
'*  - Fusebit A987: 1111 (1111 external XTAL)                                        *
'* Fusebits High - bez zmian                                                         *
'*************************************************************************************

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw wykorzystywanego mikrontrolera
$crystal = 8000000                                          'informuje kompilator o czestotliwosci rezonatora kwarcowego
$lib "mcsbyte.lbx"                                          'biblioteka z nowszymi procedurami

Config Portb = Output                                       'konfiguracja portow
Config Pinc.4 = Output                                      'konfiguracja portow
Config Pinc.0 = Input                                       'konfiguracja portow
Config Pinc.1 = Output                                      'konfiguracja portow
Config Pinc.3 = Output                                      'konfiguracja portow
Config Pinc.2 = Output                                      'konfiguracja portow
Config Pind.7 = Output                                      'konfiguracja portow
Config Pind.4 = Output                                      'konfiguracja portow
Config Pind.6 = Input                                       'konfiguracja portow
Config Pind.5 = Input                                       'konfiguracja portow
Config Pind.2 = Output                                      'konfiguracja portow
Config Pind.3 = Output                                      'konfiguracja portow
Config Pind.2 = Input                                       'konfiguracja portow
Config Pind.1 = Input                                       'konfiguracja portow
Config Pinb.0 = Input                                       'konfiguracja portow

Config Timer0 = Timer , Prescale = 256                      'konfiguracja timer0 ktory steruje wyswietlaczem
Config Timer1 = Timer , Prescale = 256 , Capture Edge = Rising , Compare A No_output = Disconnect       'konfiguracja timer1
Config Adc = Single , Prescaler = Auto , Reference = Avcc   'konfiguracja przetwornika A/C

On Timer0 Multip_wys_kl                                     'procedura przerwnaia sterujacego wyswietlaczem
On Capture1 Capture1_int                                    'procedura przechwytywania wartosci od timer1
On Compare1a Compare1a_int                                  'procedura porownania wartosci z timer1

Declare Sub Wysw_zn                                         'procedura wyswietlajaca znaki
Declare Sub Czek_p                                          'oczekuje na puszczenie przycisku
Declare Sub Obs_led                                         'procedura obslugi wyboru wejsc oraz trybu mute
Declare Sub Zap_pa(rej As Byte)                             'zapisuje do procesora audio dany rejestr
Declare Sub Obl_we_1                                        'oblicza wartosc wzmocnia dla we1
Declare Sub Czek_p_p                                        'czeka na puszeczenie przycisku z dodatkowymi instrukcjami                                         'oblicza rejestr glosnosci
Declare Sub Wysw_opcje                                      'wyswietla wybierane opcje
Declare Sub Dod_str                                         'dodaje znaki do zmiennej typu string
Declare Sub Analizator                                      'procedura obslugujaca analizator widma

Dim Nr_wysw As Byte                                         'numer wyswietlacza matrycowego
Dim Znaki(10) As Byte                                       'zmienne na znaki kazdego z wyswietlaczy
Dim I As Byte                                               'zmienna licznikowa
Dim J As Byte                                               'zmienna licznikowa
Dim P As Byte                                               'zmienna licznikowa
Dim K As Byte                                               'zmienna licznikowa
Dim L As Byte                                               'zmienna licznikowa
Dim M As Byte                                               'zmienna licznikowa
Dim Temp1 As Byte                                           'zmienna pomocnicza dla wysw led
Dim Temp2 As Byte                                           'zmienna pomocnicza dla wysw led
Dim Temp3 As Byte                                           'zmienna pomocnicza
Dim Temp4 As Byte                                           'zmienna pomocnicza
Dim Temp5 As Byte                                           'zmienna pomocnicza
Dim Temp6 As Byte                                           'zmienna pomocnicza
Dim Temp7 As Byte                                           'zmienna pomocnicza
Dim Temp8 As Byte                                           'zmienna pomocnicza
Dim Led As Byte                                             'zmienna diod led
Dim Zn As String * 1                                        'miejsce na znak
Dim C_zn As String * 10                                     'zmianna na wyswietlany tekst
Dim Przycisk As Byte                                        'przecowuje kod przycisku
Dim Rej_aud(10) As Byte                                     'zmienne na wartosc rejestrow procesora audio
Dim Czas_przyc As Byte                                      'zmienna liczaaca czas przycisniecia przycisku                                   'liczy czas nacisniecia przycisku S1
Dim Wart_wysw As Byte                                       'zmienna okreslajaca wyswietlana zmienna
Dim Zez_na_wysw As Bit                                      'zezwala na aktualizacje wyswietlacza
Dim Par As Byte                                             'numer zmienianego parametru
Dim Nr_rej As Byte                                          'numer rejestru
Dim Nr_str As Byte                                          'okresla numer znaku w zmiennej string
Dim Nr_led As Byte                                          'przechoduje informacje o zapalonej diodzie led
Dim Tryb As Byte                                            'zmienna okresla tryb pracy
Dim Czas_mig As Byte                                        'czas migania suwaka equalizera
Dim Flag_m As Bit                                           'flaga okreslajaca stan suwaka equalizera
Dim Nr_eq As Byte                                           'numer pasma equalizera
Dim Ready As Byte                                           'flaga gotowosci odbioru kodu sony
Dim Address As Word                                         'adres kodu sony
Dim Code As Word                                            'kod odebranego kodu sony
Dim Startbitperiod As Byte                                  'bit startu sony
Dim Normalbitperiod As Byte                                 'bit normalny sony
Dim Period As Word                                          'okres
Dim Command As Long                                         'komenda
Dim Bitcount As Byte                                        'licznik bitow
Dim Shiftcount As Byte                                       'licznik przesuniec
Dim Analiz(5) As Byte                                       'tablica dla analizatora widma
Dim Wart_ac As Word                                         'wartosc odczytana z przetowornika A/C
Dim Licznik1 As Word                                        'zmienna licznikowa

Startbitperiod = 200                                        'wartosc poczatkowa zmiennej
Normalbitperiod = 45                                        'wartosc poczatkowa zmiennej
Compare1a = Normalbitperiod * 4                             'wartosc poczatkowa rejestru compare

K1 Alias Portb.1                                            'przypisanie aliasow
K2 Alias Portb.2                                            'przypisanie aliasow
K3 Alias Portb.3                                            'przypisanie aliasow
K4 Alias Portb.4                                            'przypisanie aliasow
K5 Alias Portb.5                                            'przypisanie aliasow
Clk_r Alias Portd.3                                         'przypisanie aliasow
Ab1 Alias Portd.7                                           'przypisanie aliasow
Ab2 Alias Portd.4                                           'przypisanie aliasow
Latch Alias Portc.5                                         'przypisanie aliasow
Dat Alias Portd.2                                           'przypisanie aliasow
Clk_a Alias Portc.4                                         'przypisanie aliasow
A Alias Portc.1                                             'przypisanie aliasow
B Alias Portc.2                                             'przypisanie aliasow
C Alias Portc.3                                             'przypisanie aliasow

Set Portd.1                                                 'd.1 ustawione
Set Portd.2                                                 'd.2 ustawione
Reset Clk_r                                                 'zeruj clk_r
Reset Portd.5                                               'zeruj d.5
Reset Portd.6                                               'zeruj d.6
Counter0 = 150                                              'wartosc poczatkowa licznika 0
Enable Interrupts                                           'odblokowanie globalnych przerwac
Enable Timer0                                               'wlaczone przerwanie timer0
Enable Capture1                                             'wlaczone przerwanie capture
Enable Compare1a                                            'wlaczone przerwanie compare
Start Adc                                                   'start przetwornika A/C

Par = 1                                                     'przypisanie zmiennej par wartosci 1
Tryb = 3                                                    'przypisanie zmiennej tryb wartosci 3 (analizator widma)
Waitms 700                                                  'czekaj 700 ms
Waitms 40                                                   'czekaj 40 ms
Readeeprom Temp6 , 12                                       'odczytaj warotsc eeprom z komorki 12
Waitms 90                                                   'czekaj 90 ms

If Temp6 = 255 Then                                         'jesli odczytana wartosc 255 to
  Nr_led = &B10111101                                       'wpisz wartosci poczatkowe do nr_led oraz zmiennych rejestrow procesora audio
  Rej_aud(1) = &B00000111
  Rej_aud(2) = &B10111011
  Rej_aud(3) = &B11000001
  Rej_aud(4) = &B00100000
  Rej_aud(5) = &B00110000
  Rej_aud(6) = &B01000000
  Rej_aud(7) = &B01010000
  Rej_aud(8) = &B01100000
  Rej_aud(9) = &B10000110
  Rej_aud(10) = &B11100111
  Temp6 = 15                                                'zapisz do temp6 wartosc 15
  Writeeeprom Temp6 , 12                                    'Zapisz Te Wartosc Do eeprom
  Writeeeprom Nr_led , 11                                   'zapisz do eeprom np_led
  For M = 1 To 10                                           'dla m1 do 10 zapisz do
    Writeeeprom Rej_aud(m) , M                              'eeprom wartosc zmiennych rejestrow procesora audio
  Next M
  Nr_eq = 20                                                'nr_eq = 20
  Writeeeprom Nr_eq , 13                                    'zapisz numer aktywnego equalizera do pamieci
  Do                                                        'poczatek petli
    For M = 4 To 8                                          'Dla M = 4 Do 8
      Temp5 = Nr_eq + M                                     'oblicz temp5
      Writeeeprom Rej_aud(m) , Temp5                        'zapisz wartosci rejestrow eq procesora audio do eeprom
    Next M
    Nr_eq = Nr_eq + 10                                      'oblicz nastepnego nr_eq
  Loop Until Nr_eq = 70                                     'wykonaj az nr_eq = 70
End If

Readeeprom Nr_led , 11                                      'odczytaj z eeprom nr_led
For M = 1 To 10                                             'wykonaj dla m=1 do 10
  Readeeprom Rej_aud(m) , M                                 'odczytaj z eeprom wartosci rejestrow procesora audio
  Call Zap_pa(rej_aud(m))                                   'przeslij do procesora wartosic odczytanych z eeprom rejestrow
Next M
Readeeprom Nr_eq , 13                                       'odczytaj z eeprom nr_eq

Zez_na_wysw = 1                                             'zezwolenie na wyswietlenie parametrow

Do                                                          'poczatek petli glownej programu
  Call Wysw_opcje                                           'wywolanie porcedury wyswietlajace wybrane opcje
  Call Obs_led                                              'wywolanie procedury obslugi diod LED
  Call Analizator                                           'wywolanie procedury analizatora widma
  If Przycisk = 35 Then                                     'jesli przycisk=35 to
    Licznik1 = 0                                            'zeruj licznik1
    Par = 1                                                 'zapisz do par 1
    Incr Tryb                                               'zwieksz zmienna tryb
    If Tryb = 4 Then                                        'jelsi zmienna tryb=4 to
      Tryb = 1                                              'zmienna tryb = 1
    End If
    Set Zez_na_wysw                                         'zezwolenie na wyswietlenie aktualnych wartosci
    Call Wysw_opcje                                         'wyswietlenie atualnych opcji
    Call Czek_p                                             'procedura czekajaca na puszczenie przycisku
  End If

  If Przycisk = 36 Then                                     'jesli przycisk = 36 to
    Licznik1 = 0                                            'licznik1 rowny 0
    Incr Par                                                'zwieksz par o jeden
    If Tryb = 1 Then                                        'jesli tryb = 1 oraz
      If Par = 10 Then                                      'par=10 to
        Par = 1                                             'par = 1
      End If
      Set Zez_na_wysw                                       'zezwol na wyswietlenie
      Call Wysw_opcje                                       'procedura wyswietlenia
    Else                                                    'w przeciwnym razie
      If Par = 6 Then                                       'jesli par=6 to
        Par = 1                                             'par = 1
      End If
    End If
    Call Czek_p                                             'czekaj na puszczenie przycisku
  End If

  If Tryb <> 3 Then                                         'jesli tryb rozne od 3 oraz
    If Przycisk = 37 Then                                   'jesli przycisk=37 to
      Licznik1 = 0                                          'licznik1 rowny 0
      Decr Par                                              'zmniejsz par
      If Tryb = 1 Then                                      'jesli tryb=1 oraz
        If Par = 0 Then                                     'par=0 to
          Par = 9                                           'par=9
        End If
        Set Zez_na_wysw                                     'zezwol na wyswietlenie
        Call Wysw_opcje                                     'procedura wyswietlenia
      Else                                                  'w przeciwnym razie
        If Par = 0 Then                                     'jesli par=0 to
          Par = 5                                           'par=5
        End If
      End If
      Call Czek_p                                           'czekaj na puszczenie przycisku
    End If
  End If

  If Przycisk = 33 Or Przycisk = 34 Then                    'jesli przycisk = 33 lub 34 to
    Licznik1 = 0                                            'licznik1 rowny 0
    If Tryb = 3 Then                                        'jesli tryb rowny 3 to
      Tryb = 1                                              'tryb rowny 1
      Par = 1                                               'i par rowny 1
    End If
    If Tryb = 1 Then                                        'jesli tryb rowny 1 to
      Select Case Par                                       'w zaleznosci od par wykonaj:
        Case 1:                                             'jesli par=1 to
          Nr_rej = 1                                        'nr_rej rowny 1
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Decr Rej_aud(1)                                 'zmniejsz rejestr 1
            If Rej_aud(1) = 255 Then                        'jesli rejestr 1 = 255 to
              Rej_aud(1) = 0                                'rejestr 1 rowny 0
            End If
          Else                                              'w przeciwnym razie
            Incr Rej_aud(1)                                 'zwieksz rejestr 1
            If Rej_aud(1) = 32 Then                         'jesli rejestr 1 = 32 to
              Rej_aud(1) = 31                               'rejestr 1 rowny 31
            End If
          End If
        Case 2:                                             'jesli par=2 to
          Nr_rej = 2                                        'nr_rej rowny 2
          Temp3 = Rej_aud(2) And &B00000111                 'przeliczenie wartosci danego rejestru audio
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Incr Temp3                                      'zwieksz temp3
            If Temp3 = 8 Then                               'jesli temp3 rowne 8 to
              Temp3 = 7                                     'temp3 rowne 7
            End If
          Else                                              'w przeciwnym razie
            Decr Temp3                                      'zmniejsz temp3
            If Temp3 = 2 Then                               'jesli temp3 rowne 2 to
              Temp3 = 3                                     'temp3 rowne 3
            End If
          End If
          Rej_aud(2) = Rej_aud(2) And &B11111000            'przeliczenie wartosci danego rejestru audio
          Rej_aud(2) = Rej_aud(2) Or Temp3                  'przeliczenie wartosci danego rejestru audio
        Case 3:                                             'jesli par=3 to
          Nr_rej = 2                                        'nr_rej rowny 2
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Rej_aud(2).3 = 0                                'zeruj bit 3 rejestru 2
          Else                                              'w przeciwnym razie
            Rej_aud(2).3 = 1                                'ustaw bit 3 rejestru 2
          End If
        Case 4:                                             'jesli par=4 to
          Nr_rej = 2                                        'nr_rej rowny 2
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Rej_aud(2).4 = 0                                'zeruj bit 4 rejestru 2
          Else                                              'w przeciwnym razie
            Rej_aud(2).4 = 1                                'ustaw bit 4 rejestru 2
          End If
        Case 5                                              'jesli par=5 to
          Nr_rej = 9                                        'nr_rej rowny 9
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Rej_aud(9).3 = 0                                'zeruj bit 3 rejestru 9
          Else                                              'w przeciwnym razie
            Rej_aud(9).3 = 1                                'ustaw bit 3 rejestru 9
          End If
        Case 6:                                             'jesli par=6 to
          Nr_rej = 3                                        'nr_rej rowny 3
          Temp3 = Rej_aud(3) And &B00011000                 'przeliczenie wartosci danego rejestru audio
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Temp3 = Temp3 + 8                               'przzelicz temp3
            If Temp3 > 24 Then                              'jesli temp3 wieksze niz 24 to
              Temp3 = 24                                    'temp3 rowne 24
            End If
          Else                                              'w przeciwnym razie
            Temp3 = Temp3 - 8                               'przelicz temp3
            If Temp3 > 200 Then                             'jesli temp3 wieksze od 200 to
              Temp3 = 0                                     'temp3 rowne 0
            End If
          End If
          Rej_aud(3) = Rej_aud(3) And &B11100111            'przeliczenie wartosci danego rejestru audio
          Rej_aud(3) = Rej_aud(3) Or Temp3                  'przeliczenie wartosci danego rejestru audio
        Case 7:                                             'jesli par=7 to
          Nr_rej = 9                                        'nr_rej rowny 9
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Rej_aud(9).4 = 0                                'zeruj bit 4 rejestru 9
          Else                                              'w przeciwnym razie
            Rej_aud(9).4 = 1                                'zeruj bit 4 rejestru 9
          End If
        Case 8:                                             'jesli par=8 to
          Nr_rej = 3                                        'nr_rej rowny 3
          Temp3 = Rej_aud(3) And &B00000111                 'przeliczenie wartosci danego rejestru audio
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Incr Temp3                                      'zwieksz temp3
            If Temp3 = 8 Then                               'jesli temp3 rowne 8 to
              Temp3 = 7                                     'temp3 rowne 7
            End If
          Else                                              'w przeciwnym razie
            Decr Temp3                                      'zmniejsz temp3
            If Temp3 = 0 Then                               'jesli temp3 rowne 0 to
              Temp3 = 1                                     'temp3 rowne 1
            End If
          End If
          Rej_aud(3) = Rej_aud(3) And &B11111000            'przeliczenie wartosci danego rejestru audio
          Rej_aud(3) = Rej_aud(3) Or Temp3                  'przeliczenie wartosci danego rejestru audio
        Case 9                                              'jesli par=9 to
          Nr_rej = 8                                        'nr_rej rowny 8
          If Przycisk = 33 Then                             'jesli przycisk rowny 33 to
            Nr_led.6 = 1                                    'ustaw bit 6 zmiennej nr_led
          Else                                              'w przeciwnym razie
            Nr_led.6 = 0                                    'zeruj bit 6 zmiennej nr_led
          End If
          Writeeeprom Nr_led , 11                           'zapisz nr_led do eeprom
          Waitms 10                                         'czekaj 10 ms
      End Select                                            'koniec instrukcji wyboru
      Call Czek_p_p                                         'zapis do procesora audio zmienionych paramentrow
    Else                                                    'w przeciwnym razie
      Temp3 = Rej_aud(par + 3) And &B00001111               'przeliczenie wartosci danego rejestru audio
      If Przycisk = 33 Then                                 'jesli przycisk rowny 33 oraz
        If Temp3 > 8 Then                                   'jesli temp3 wieksze od 8 to
          Incr Temp3                                        'zwieksz temp3
          If Temp3 = 15 Then                                'jesli temp3 rowne 15 to
            Temp3 = 14                                      'temp3 rowne 14
          End If
        End If
        If Temp3 < 8 Then                                   'jesli temp3 mniejsze od 8 to
          Decr Temp3                                        'zmniejsz temp3
        End If
        If Temp3 > 100 Then                                 'jesli temp3 wieksze od 100 to
          Temp3 = 9                                         'temp3 rowne 9
        End If
      Else                                                  'w przeciwnym razie
        If Temp3 < 8 Then                                   'jesli temp3 mniejsze od 8 to
          Incr Temp3                                        'zwieksz temp3
          If Temp3 = 7 Then                                 'jesli temp3 rowne 7 to
            Temp3 = 6                                       'temp3 rowne 6
          End If
        End If
        If Temp3 > 8 Then                                   'jesli temp3 wieksze od 8 to
          Decr Temp3                                        'zmniejsz temp3
        End If
        If Temp3 = 8 Then                                   'jesli temp3 rowne 8 to
          Temp3 = 0                                         'temp3 rowne 0
        End If
      End If
      Rej_aud(par + 3) = Rej_aud(par + 3) And &B11110000    'przeliczenie wartosci danego rejestru audio
      Rej_aud(par + 3) = Rej_aud(par + 3) Or Temp3          'przeliczenie wartosci danego rejestru audio
      Call Czek_p_p                                         'wywolanie procedury wpisujacej rejestr do procesora audio oraz czekajacej na puszczenie przycisku
      Nr_rej = Par + 3                                      'obliczenie nr_rej
      Temp5 = Nr_eq + Nr_rej                                'obliczenie temp5
      Writeeeprom Rej_aud(nr_rej) , Temp5                   'zapis wartosci temp5 do eeprom (zapis ustawien equalizera0
    End If
  End If
Loop                                                        'koniec petli glownej programu
End                                                         'koniec programu

Sub Analizator                                              'procedura analizatora widma
  If Tryb = 3 Then                                          'jesli tryb=3 to
    Led = Nr_led                                            'przepisz nr_led od led
    For L = 1 To 5                                          'wykonal dla L= 1 do L=5
      Reset A                                               'zeruj a
      Reset B                                               'zeruj b
      Reset C                                               'zeruj c
      Waitus 500                                            'czekaj 500 us
      Select Case L                                         'istrukcje wykonywane wzaleznosci od l
        Case 1 :                                            'gdy l=1
          Reset A                                           'odpowiednie ustawienie a, b oraz c
          Reset B
          Set C
        Case 2 :                                            'gdy l=2
          Reset A                                           'odpowiednie ustawienie a, b oraz c
          Set B
          Reset C
        Case 3:                                             'gdy l=3
          Set A                                             'odpowiednie ustawienie a, b oraz c
          Reset B
          Reset C
        Case 4 :                                            'gdy l=4
          Set A                                             'odpowiednie ustawienie a, b oraz c
          Set B
          Reset C
        Case 5 :                                            'gdy l=5
          Set A                                             'odpowiednie ustawienie a, b oraz c
          Set B
          Set C
      End Select                                            'koniec instrukcji wyboru
      Waitms 1                                              'czekaj 1 ms
      Wart_ac = Getadc(0)                                   'odczytaj wartosc zmierzona przez przetwornik A/C
      Select Case Wart_ac                                   'instrukcje wykonywane w zaleznosci od wartosci odczytanej z przetwornika
        Case Is > 922 : Temp7 = 29                          'jesli wartosc wieksza niz 922 to zapisz do temp7 wartosc 29
        Case Is > 819 : Temp7 = 28                          'jesli wartosc wieksza niz 819 to zapisz do temp7 wartosc 28
        Case Is > 768 : Temp7 = 27                          'jesli wartosc wieksza niz 768 to zapisz do temp7 wartosc 27
        Case Is > 676 : Temp7 = 26                          'jesli wartosc wieksza niz 676 to zapisz do temp7 wartosc 26
        Case Is > 606 : Temp7 = 25                          'jesli wartosc wieksza niz 606 to zapisz do temp7 wartosc 25
        Case Is > 549 : Temp7 = 24                          'jesli wartosc wieksza niz 549 to zapisz do temp7 wartosc 24
        Case Is > 495 : Temp7 = 23                          'jesli wartosc wieksza niz 495 to zapisz do temp7 wartosc 23
        Case Is > 397 : Temp7 = 22                          'jesli wartosc wieksza niz 397 to zapisz do temp7 wartosc 22
        Case Is > 317 : Temp7 = 21                          'jesli wartosc wieksza niz 317 to zapisz do temp7 wartosc 21
        Case Is > 252 : Temp7 = 20                          'jesli wartosc wieksza niz 252 to zapisz do temp7 wartosc 20
        Case Is > 180 : Temp7 = 19                          'jesli wartosc wieksza niz 180 to zapisz do temp7 wartosc 19
        Case Is > 118 : Temp7 = 18                          'jesli wartosc wieksza niz 118 to zapisz do temp7 wartosc 18
        Case Is > 77 : Temp7 = 17                           'jesli wartosc wieksza niz 77 to zapisz do temp7 wartosc 17
        Case Else Temp7 = 16                                'w przeciwnym razie temp7 rowne 16
      End Select                                            'koniec instrukcji wyboru
      Do                                                    'poczatek petli do-loop
        If Analiz(l) < Temp7 Then                           'jesli analiz(l) mniejszy od temp7 to
          Incr Analiz(l)                                    'zwieksz analiz(l)
        End If
        If Analiz(l) > Temp7 Then                           'jesli analiz(l) wiekszy od temp7 to
          Decr Analiz(l)                                    'zmniejsz analiz(l)
        End If
        If Analiz(l) < 23 Then                              'jesli analiz(l) wiekszy od 23 to
          Znaki(l + 5) = Analiz(l)                          'zapisz odpowiednia wartosc do znaki(l+5)
          Znaki(l) = 15                                     'zapis wartosci 15 do znaki(l)
        Else
          Znaki(l + 5) = 22                                 'zapis wartosci 15 do znaki(l+5)
          Znaki(l) = Analiz(l) - 7                          'zapisz odpowiednia wartosc do znaki(l)
        End If
        Waitms 2                                            'czekaj 2 ms
      Loop Until Temp7 = Analiz(l)                          'wykonuj petle do-loop az analiz(l) rowne bedzie temp7
    Next L                                                  'zwieksz wartosc L
  End If
End Sub                                                     'koniec procedury

Sub Wysw_opcje                                              'procedura wyswietlajaca ustawiana parametry na wyswietlaczu
  If Zez_na_wysw = 1 Then                                   'jesli flaga zezwolenie ustawiona to
    Zez_na_wysw = 0                                         'zeruj te flage
    If Tryb = 1 Then                                        'jesli tryb rowne 1 to
      Led = Nr_led                                          'zapisz do led wartosc nr_led
      Select Case Par                                       'wykonaj w zaleznosci od par okreslone instrukcje
        Case 1:                                             'gdy par rowne 1 to
          C_zn = "Vol  "                                    'zapisz do c_zn wyswietlany parametr
          If Rej_aud(1) < 21 Then                           'jesli rejestr 1 wiekszy nic 21 to
            Wart_wysw = Rej_aud(1) * 2                      'oblicz wartosc do wyswietlenia
          Else                                              'w przeciwnym razie
            Wart_wysw = Rej_aud(1) Mod 20                   'przelicz w inny sposob wyswietlana wartosc
            Wart_wysw = Wart_wysw * 4
            Wart_wysw = Wart_wysw + 40
          End If
          If Rej_aud(1) = 30 Then                           'jesli rejestr 1 rowny 30 to
            Wart_wysw = 82                                  'zapisz zmiennej wart_wysw liczbe 82
          End If
          If Wart_wysw = 0 Then                             'jesli wart_wysw rowna zero to
            Nr_str = 0                                      'Nr_str Rowny 0
          Else                                              'w przeciwnym razie
            Nr_str = 1                                      'Nr_str Rowny 1
          End If
          Call Dod_str                                      'dodaj string
          If Wart_wysw > 0 And Wart_wysw < 10 Then
            Nr_str = 2
            Call Dod_str                                    'dodaj string
          End If
          If Rej_aud(1) = 31 Then                           'jesli rejestr 1 rowny 31 to
            Nr_str = 3                                      'zapisz do nr_str wartosc 3
            Call Dod_str                                    'dodaj string
          Else                                              'w przeciwnym razie
            C_zn = C_zn + Str(wart_wysw)                    'dodaj do c_zn wartosc zmiennej wart_wysw
          End If
          Nr_str = 4                                        'zapisz no nr_str wartosc 4
        Case 2:                                             'gdy par rowne 2 to
          C_zn = "Mode "                                    'zapisz do c_zn wyswietlany parametr
          Temp3 = Rej_aud(2) And &B00000111                 'odpowiednie obliczenie temp3
          Nr_str = Temp3 + 2                                'obliczenie nr_str
        Case 3:                                             'gdy par rowne 3 to
          C_zn = "Mic  "                                    'zapisz do c_zn wyswietlany parametr
          Nr_str = 11                                       'zapisz do nr_str wartosc 11
          If Rej_aud(2).3 = 0 Then                          'jesli bit 3 rejestru 2 rowny zero to
            Nr_str = 10                                     'zapisz do nr_str wartosc 10
          End If
        Case 4:                                             'gdy par rowne 4 to
          C_zn = "Rec  "                                    'zapisz do c_zn wyswietlany parametr
          Nr_str = 11                                       'zapisz do nr_str wartosc 11
          If Rej_aud(2).4 = 0 Then                          'jesli bit 4 rejestru 2 rowny zero to
            Nr_str = 10                                     'zapisz do nr_str wartosc 10
          End If
        Case 5:                                             'gdy par rowne 5 to
          C_zn = "Su-Si"                                    'zapisz do c_zn wyswietlany parametr
          Nr_str = 13                                       'zapisz do nr_str wartosc 13
          If Rej_aud(9).3 = 0 Then                          'jesli bit 3 rejestru 9 rowny zero to
            Nr_str = 12                                     'zapisz do nr_str wartosc 12
          End If
        Case 6:                                             'gdy par rowne 6 to
          C_zn = "Su-Si  "                                  'zapisz do c_zn wyswietlany parametr
          Wart_wysw = Rej_aud(3) And &B00011000             'odpowiednie obliczenie wart_wysw
          Wart_wysw = Wart_wysw / 8                         'dalsze obliczenie wart_wysw
          Wart_wysw = Wart_wysw * 3                         'dalsze obliczenie wart_wysw
          C_zn = C_zn + Str(wart_wysw)                      'dodaj do c_zn wartosc zmiennej wart_wysw
          Nr_str = 4                                        'zapisz do nr_str wartosc 4
        Case 7:                                             'gdy par rowne 7 to
          C_zn = "DB-Bi"                                    'zapisz do c_zn wyswietlany parametr
          Nr_str = 15
          If Rej_aud(9).4 = 0 Then                          'jesli bit 4 rejestru 9 rowny zero to
            Nr_str = 14                                     'zapisz do nr_str wartosc 14
          End If
        Case 8:                                             'gdy par rowne 8 to
          C_zn = "DB-Bi "                                   'zapisz do c_zn wyswietlany parametr
          Wart_wysw = Rej_aud(3) And &B00000111             'odpowiednie obliczenie wart_wysw
          Decr Wart_wysw                                    'zmniejsz wart_wysw
          Wart_wysw = Wart_wysw * 3                         'obliczenie wart_wysw
          If Wart_wysw < 10 Then                            'jesli wart_wysw mniejsza niz 10 to
            Nr_str = 2                                      'zapisz do nr_str wartosc 2
            Call Dod_str                                    'dodaj string
          End If
          C_zn = C_zn + Str(wart_wysw)                      'dodaj do c_zn wartosc zmiennej wart_wysw
          Nr_str = 4                                        'zapisz do nr_str wartosc 4
        Case 9:                                             'gdy par rowne 9 to
          C_zn = "DPL  "                                    'zapisz do c_zn wyswietlany parametr
          Nr_str = 10
          If Nr_led.6 = 0 Then                              'jesli bit 6 zmiennej nr_led rowny 0 to
            Nr_str = 16                                     'zapisz do nr_str wartosc 16
          End If
      End Select                                            'koniec instrukcji wyboru
      Call Dod_str                                          'dodaj string
      For P = 1 To 10                                       'wykonaj dla p=1 do p=10
        Zn = Mid(c_zn , P , 1 )                             'zapisz do zn powyzje znaku w lancuchu c_zn
        Znaki(p) = Asc(zn)                                  'zamiec zn na kod ascii wpisywany na odpowiednia pozycje wyswietlacza
      Next P                                                'zwieksz p
    End If
    If Tryb = 2 Then                                        'jesli tryb rowny 2 to
      Temp5 = 255                                           'temp5 rowne 255
      Temp6 = Nr_eq - 10                                    'obliczenie temp6
      Temp6 = Temp6 / 10                                    'dalsze obliczenie temp6
      Reset Temp5.temp6                                     'zerowanie bitu okreslonego przez temp6 w zmiennej temp5
      Led = Temp5                                           'zapis do te wartosci zmiennej temp5
      For L = 1 To 5                                        'wykonanie dla l=1 to l=5
        Temp4 = Rej_aud(l + 3) And &B00001111               'obliczenie temp4
        If Temp4 < 8 Then                                   'jesli temp4 mniejsze od 8 to
          Temp4 = 7 - Temp4                                 'oblicz temp4
          Znaki(l + 5) = Temp4                              'zapisz temp4 do znaki(l+5)
          Znaki(l) = 14                                     'zpisz do znaki(l) wartosc 14
        Else                                                'w przeciwnym razie
          Temp4 = Temp4 - 1                                 'oblicz temp4
          Znaki(l + 5) = 0                                  'zapisz 0 do znaki(l+5)
          Znaki(l) = Temp4                                  'zapisz temp4 do znaki(l)
        End If
      Next L                                                'zwieksz l
    End If
  End If
End Sub                                                     'koniec procedury

Sub Dod_str                                                 'procedura dodania stringu
  C_zn = C_zn + Lookupstr(nr_str , Strin)                   'dodanie do c_zn znakow odczytanych z tablicy strin z pozycji nr_str
End Sub                                                     'koniec procedury

Sub Czek_p_p                                                'rozbudowana procedura oczekiwania na puszczenie przycisku
  Writeeeprom Rej_aud(nr_rej) , Nr_rej                      'zapisanie do eeprom zmienianego rejestru procesora audio
  Call Zap_pa(rej_aud(nr_rej))                              'zapis rejestru do procesora audio
  Set Zez_na_wysw                                           'zezwolenie na wyswietlenie
  Call Wysw_opcje                                           'wywolanie procedury wyswietlajacej
  If Nr_rej = 1 Or Nr_rej = 3 Or Tryb = 2 Then              'jesli nr_rej = 1 lub nr_rej=3 lub tryb 2 to
    Waitms 150                                              'czekaj 150 ms
  Else                                                      'w przewciwnym razie
    Call Czek_p                                             'wywolaj procedure czek_p
  End If
  Przycisk = 0                                              'przycisk rowny 0
  Ready = 0                                                 'ready rowne 0
End Sub                                                     'koniec procedury

Sub Zap_pa(rej As Byte)                                     'procedura zapisu wartosci do procesora audio zawartej w rej
  Temp8 = Rej And &B11100000                                'obliczenie temp8
  If Temp8 = &B01100000 Then                                'jesli temp8 rowne &b11100000 to
    Rej.4 = Nr_led.6                                        'zapisz do bitu 4 rej stan bitu 6 zmiennej nr_led
  End If
  P = 8                                                     'zapisz do p wartosc 8
  For K = 0 To 7                                            'petla wykonywana od k=0 to k=7
    Decr P                                                  'zwieksz p
    Temp3.p = Rej.k                                         'oblicz temp3
  Next K                                                    'zwieksz k
  Reset Ddrc.5                                              'linia c.5 jako wejscie
  Reset Latch                                               'zeruj latch
  Reset Clk_a                                               'zeruj clk_a
  Shiftout Dat , Clk_a , Temp3 , 1 , Null , 2               'wyslij do procesora audio wartosc temp3
  Reset Dat                                                 'zeruj dat
  Set Ddrc.5                                                'linia c.5 jako wyjscie
  Set Latch                                                 'ustaw latch
  Waitus 2                                                  'czekaj 2 us
  Reset Latch                                               'seruj latch
End Sub                                                     'koniec procedury

Sub Obs_led                                                 'procedura obslugi led
  If Przycisk > 64 Then                                     'jesli przycisk wiekszy od 64 to
    Licznik1 = 0                                            'licznik1 rowny 0
    If Tryb = 2 Then                                        'jesli tryb rowny 2 to
      Par = 1                                               'par rowny 1
      Nr_eq = Przycisk - 63                                 'obliczenie nr_eq
      Nr_eq = Nr_eq * 10                                    'dalsze obliczenie nr_eq
      Set Zez_na_wysw                                       'zezwolenie na wyswietlenie
      Call Wysw_opcje                                       'procedura wyswietlenia
      Writeeeprom Nr_eq , 13                                'zapisanie nr_eq do eeprom
      For M = 4 To 8                                        'petla wykonywana dla m=4 do m=8
        Temp5 = Nr_eq + M                                   'onliczenie temp5
        Readeeprom Rej_aud(m) , Temp5                       'odczytanie z eeprom rejestrow equalizara na pozycjach okreslonych przez temp5
        Writeeeprom Rej_aud(m) , M                          'zapisanie do eeprom rejestrow equalizara na pozycjach okreslonych przez m
        Call Zap_pa(rej_aud(m))                             'zapis ustawien equalizaro do procesora audio
      Next M                                                'zwieksz m
      Call Czek_p                                           'czekaj na puszczenie przycisku
    Else                                                    'w przeciwnym razie
      Nr_rej = 9                                            'zapisz do rej_aud wartosc 9
      Nr_led = Nr_led Or &B00111110                         'obliczenie nr_led
      Rej_aud(9) = Rej_aud(9) And &B11111000                'obliczenie rejestru 9
      Select Case Przycisk                                  'w zaleznosci od wartosci przycisk wykonaj
        Case 65:                                            'jesli 65 to
          Reset Nr_led.1                                    'zeruj bit 1 zmiennej nr_led
          Led = Nr_led                                      'zapisz do led wartosc nr_led
          Czas_przyc = 0                                    'zeruj zmienna czas_przyc
          Call Obl_we_1                                     'wywolaj procedure obliczenia wzmocnienia wejscia 1 sygnalu audio
          Call Zap_pa(rej_aud(9))                           'zapisanie rejestru 9 do procesora audio
          Writeeeprom Rej_aud(9) , Nr_rej                   'zapisanie rejestru 9 do eeprom
          Do                                                'poczatek petli do-loop
            Przycisk = 0                                    'przycisk rowny 0
            If Tryb = 3 Then                                'jesli tryb rowny 3 to
              For Temp8 = 1 To 2                            'wykonaj petle 2 razy
                Call Analizator                             'wywolaj procedure analizatora
              Next Temp8                                    'zwieksz temp8
            Else                                            'w przeciwnym razie
              Waitms 15                                     'czekaj 15 ms
            End If
            Incr Czas_przyc                                 'zwieksz czas_przyc
            If Czas_przyc = 80 Then                         'jesli czas_przyc rowne 80 to
              Toggle Nr_led.0                               'zmien na przciwny stan bitu 0 zmiennej nr_led
              Set Led.1                                     'wylacz led 1
              Waitms 200                                    'czekaj 200 ms
              Reset Led.1                                   'wlacz led 1
              Exit Do                                       'wyjdz z petli do-loop
            End If
          Loop Until Przycisk = 0                           'petla wykonywana az przycisk rowny 0
          Rej_aud(9) = Rej_aud(9) And &B11111000            'obliczenie rejestru 9
          Call Obl_we_1                                     'wywolaj procedure obliczenia wzmocnienia wejscia 1 sygnalu audio
        Case 66:                                            'jesli 66 to
          Reset Nr_led.2                                    'zeruj bit 2 zmiennej nr_led
          Rej_aud(9) = Rej_aud(9) Or &B00000011             'obliczenie rejestru 9
        Case 67:                                            'jesli 67 to
          Reset Nr_led.3                                    'zeruj bit 3 zmiennej nr_led
          Rej_aud(9) = Rej_aud(9) Or &B00000010             'obliczenie rejestru 9
        Case 68:                                            'jesli 68 to
          Reset Nr_led.4                                    'zeruj bit 4 zmiennej nr_led
          Rej_aud(9) = Rej_aud(9) Or &B00000001             'obliczenie rejestru 9
        Case 69:                                            'jesli 69 to
          Reset Nr_led.5                                    'zeruj bit 5 zmiennej nr_led
      End Select                                            'koniec instrukcji wyboru
      Led = Nr_led                                          'zapisz do led wartosc nr_led
      Call Czek_p_p                                         'wywolaj procedure wysylajaca dane do procesora audio i czekajaca na puszczenie przycisku
      Writeeeprom Nr_led , 11                               'zapisz nr_led do eeprom
    End If
  End If
End Sub                                                     'koniec procedury

Sub Obl_we_1                                                'procedure obliczenia wzmocnienia wejscia 1 sygnalu audio
  If Nr_led.0 = 1 Then                                      'jesli bit 0 zmiennej nr_led wyzerowany to
    Rej_aud(9) = Rej_aud(9) Or &B00000110                   'oblicz rejestr 9
  Else                                                      'w przeciwnym razie
    Rej_aud(9) = Rej_aud(9) Or &B00000111                   'oblicz rejestr 9 dla innego wzmocniania wejscia 1 audio
  End If
End Sub                                                     'koniec procedury

Sub Czek_p                                                  'procedura czekajaca na puszczenie przycisku
  Do                                                        'poczatek petli do-loop
    Przycisk = 0                                            'zapisanie do przycisk wartosci 0
    If Tryb = 3 Then                                        'jesli tryb rowny 3 to
      For Temp8 = 1 To 5                                    'wykonaj petle 5 razy
       Call Analizator                                      'wywolaj procedure analizatora
      Next Temp8                                            'zwieksz temp8
    Else                                                    'w przeciwnym razie
      Waitms 100                                            'czekaj 100 ms
    End If
  Loop Until Przycisk = 0                                   'wykonuj petle az przycisk rowny 0
End Sub                                                     'koniec procedury

Sub Wysw_zn                                                 'procedura wyswietlenia znaku
  For J = 5 To 1 Step -1                                    'wykonaj petle od j=5 do j=1
    Select Case Nr_wysw                                     'w zaleznosci od nr_wysw wykonaj:
      Case 1 :                                              'Gdy Nr_wysw Rowny 1
        Temp1 = Lookup(znaki(j) , Kol1)                     'zapisz wartosc odczytana z tablic kol1 do temp1
        Temp2 = Lookup(znaki(j + 5) , Kol1)                 'zapisz wartosc odczytana z tablic kol1 do temp2
      Case 2:                                               'Gdy Nr_wysw Rowny 2
        Temp1 = Lookup(znaki(j) , Kol2)                     'zapisz wartosc odczytana z tablic kol2 do temp1
        Temp2 = Lookup(znaki(j + 5) , Kol2)                 'zapisz wartosc odczytana z tablic kol2 do temp2
      Case 3:                                               'Gdy Nr_wysw Rowny 3
        Temp1 = Lookup(znaki(j) , Kol3)                     'zapisz wartosc odczytana z tablic kol3 do temp1
        Temp2 = Lookup(znaki(j + 5) , Kol3)                 'zapisz wartosc odczytana z tablic kol3 do temp2
      Case 4:                                               'Gdy Nr_wysw Rowny 4
        Temp1 = Lookup(znaki(j) , Kol4)                     'zapisz wartosc odczytana z tablic kol4 do temp1
        Temp2 = Lookup(znaki(j + 5) , Kol4)                 'zapisz wartosc odczytana z tablic kol4 do temp2
      Case 5:                                               'Gdy Nr_wysw Rowny 5
        Temp1 = Lookup(znaki(j) , Kol5)                     'zapisz wartosc odczytana z tablic kol5 do temp1
        Temp2 = Lookup(znaki(j + 5) , Kol5)                 'zapisz wartosc odczytana z tablic kol5 do temp2
    End Select                                              'koniec instrukcji warunkowej
    Temp1.0 = Led.nr_wysw                                   'zapisz do bitu 0 zmiennej temp wartosc bitu led okreslonego nr_wysw
    For I = 0 To 7                                          'wykonaj petle dla i=0 to i=7
      Ab1 = Temp2.i                                         'zapisz dany bit do ab1 zmiennej temp2
      Ab2 = Temp1.i                                         'zapisz dany bit do ab2 zmiennej temp1
      Set Clk_r                                             'ustaw clk_r
      Reset Clk_r                                           'zeruj clk_r
    Next I                                                  'zwieksz i
  Next J                                                    'zwieksz j
End Sub                                                     'koniec procedury

Multip_wys_kl:                                              'podprogram przerwnaia timer0
  Enable Interrupts                                         'odblokowanie przerwan globalnych
  Counter0 = 150                                            'wartoscp oczatkowa licznika
  Incr Licznik1                                             'zwieksz licznik1
  If Licznik1 = 1700 Then                                   'jesli licznik1 rowny 1700 to
    Licznik1 = 1699                                         'zapisz do licznik1 wartosc 1699
    Par = 1                                                 'zapisz do par wartosc 1
    Tryb = 3                                                'zapisz do tryb wartosc 3
  End If
  If Tryb = 2 Then                                          'jesli tryb rowny 2 to
    Incr Czas_mig                                           'zwieksz czas_mig
    If Czas_mig = 80 Then                                   'jesli czas_mig rowny 80 to
      Czas_mig = 0                                          'czas_mig rowny 0
      Toggle Flag_m                                         'zmien na przeciwny stan flagi flag_m
      If Flag_m = 1 Then                                    'jesli flag_m rowna 1 to
        Znaki(par + 5) = 0                                  'zapisz do znaki(par+5) wartosc 0
        Znaki(par) = 14                                     'zapisz do znaki(par) wartosc 14
      Else                                                  'w przeciwnym razie
        Zez_na_wysw = 1                                     'zezwol na wyswietlenie
        Call Wysw_opcje                                     'wywolaj procedure wyswietlenia
      End If
    End If
  End If
  Portb = Portb Or &B00111110                               'oblicz stan linii portu b
  Call Wysw_zn                                              'wywolanie procedury zapisu znaku do rejestrow wyswietlacza
  Select Case Nr_wysw                                       'w zaleznosci od zr_wysw
    Case 1 : Reset K1                                       'gdy ma 1 zeruj k1
    Case 2 : Reset K2                                       'gdy ma 2 zeruj k2
    Case 3 : Reset K3                                       'gdy ma 3 zeruj k3
    Case 4 : Reset K4                                       'gdy ma 4 zeruj k4
    Case 5 : Reset K5                                       'gdy ma 5 zeruj k5
  End Select                                                'koniec instrukcji wyboru
  If Pind.5 = 1 Or Pind.6 = 1 Then                          'jesli wejscie d.5 lub d.6 maja stany 1 to
    Przycisk = Pind And &B01100000                          'oblicz przycisk
    Przycisk = Przycisk + Nr_wysw                           'dodaj do przycisk wartosc nr_wysw
  End If
  Incr Nr_wysw                                              'zwieksz nr_wysw
  If Nr_wysw = 6 Then                                       'jesli nr_wysw rowny 6 to
    Nr_wysw = 0                                             'wyzeruj nr_wysw
  End If
Return                                                      'powrot z przerwania

Compare1a_int:                                              'przerwnaie compare1a od timer 1 (odczyt kodu sony)
  Enable Timer0                                             'odblokowanie przerwania timer0
  If Ready = 0 Then                                         'jesli ready rowne 0 to
    Ready = 1                                               'ready rowne 1
    If Bitcount = 12 Or Bitcount = 15 Or Bitcount = 20 Then 'jesli bitcount rowne 12 lub 15 lub 20 to
      Shiftcount = 31 - Bitcount                            'oblicz shiftcount
      Shift Command , Right , Shiftcount                    'przesun bity w command
    Else                                                    'w przeciwnym razie
      Ready = 0                                             'wyzeruj ready
    End If
    Code = Command And &H0000007F                           'obliczenie code
    Shift Command , Right , 7                               'obliczenie command
    Address = Command                                       'zapis command do zmiennej adress
    Bitcount = 0                                            'wyzerowanie bitcount
    If Ready <> 0 Then                                      'jesli ready rozne od 0 to
      Select Case Code                                      'w zaleznosci od code wykonaj
        Case 0 : Przycisk = 65                              'jesli code rowne 0 to zapisz do przycisk wartosc 65
        Case 1 : Przycisk = 66                              'jesli code rowne 1 to zapisz do przycisk wartosc 66
        Case 2 : Przycisk = 67                              'jesli code rowne 2 to zapisz do przycisk wartosc 67
        Case 3 : Przycisk = 68                              'jesli code rowne 3 to zapisz do przycisk wartosc 68
        Case 20 : Przycisk = 69                             'jesli code rowne 20 to zapisz do przycisk wartosc 69
        Case 18 : Przycisk = 33                             'jesli code rowne 18 to zapisz do przycisk wartosc 33
        Case 19 : Przycisk = 34                             'jesli code rowne 19 to zapisz do przycisk wartosc 34
        Case 16 : Przycisk = 36                             'jesli code rowne 16 to zapisz do przycisk wartosc 36
        Case 17 : Przycisk = 37                             'jesli code rowne 17 to zapisz do przycisk wartosc 37
        Case 9 : Przycisk = 35                              'jesli code rowne 9 to zapisz do przycisk wartosc 35
      End Select
      Ready = 0                                             'wyzeruj ready
    End If
  End If
Return                                                      'powrot z przerwania

Capture1_int:                                               'przerwnaie capture1 od timer 1 (odczyt kodu sony)
  Timer1 = 0                                                'wyzeruj timer1
  Period = Capture1                                         'zapisz do period wartosc capture1
  If Period >= Startbitperiod Then                          'jesli period wieksze lub rowne startbitperiod to
    Command = 0                                             'command rowne 0
    Bitcount = 0                                            'bitcount rowne 0
  Else                                                      'w przeciwnym razie
    If Period > Normalbitperiod Then                        'jesli period wieksze od normalbitperiod to
      Command = Command Or &H80000000                       'oblicz command
    End If
    Shift Command , Right                                   'przesun bity zmiennej command w prawo
    Incr Bitcount                                           'zwieksz bit count
  End If
Return                                                      'powrot z przerwania

Strin:                                                      'tablica stringow
Data "  " , "-" , " " , "><" , "dB" , "ST   " , "Voc F" , "L Mon" , "R Mon" , "L+R  " , "On   " ,
Data "Mute " , "Surr " , "Sim S" , "Dyn B" , "Biamp" , "OFF  "

Kol1:                                                       'tablica dla kolumn 1 wyswietlaczy led
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 253 , 249 , 241 , 225 , 193 , 129 , 1 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 239 , 255 , 239 , 255 , 255
Data 131 , 255 , 189 , 123 , 231 , 27 , 195 , 127 , 147 , 159 , 255 , 255 , 239 , 215 , 255 , 191
Data 179 , 129 , 0 , 131 , 0 , 0 , 0 , 131 , 0 , 255 , 251 , 0 , 0 , 0 , 0 , 131
Data 0 , 131 , 0 , 157 , 127 , 3 , 7 , 3 , 57 , 31 , 121 , 255 , 255 , 255 , 255 , 255 , 255
Data 251 , 0 , 227 , 227 , 227 , 239 , 207 , 0 , 255 , 251 , 0 , 255 , 193 , 193 , 227 , 193
Data 239 , 193 , 237 , 223 , 195 , 199 , 195 , 221 , 207 , 221

Kol2:                                                       'tablica dla kolumn 2 wyswietlaczy led
Data 255 , 253 , 251 , 247 , 239 , 223 , 191 , 127 , 253 , 251 , 247 , 239 , 223 , 191 , 255 , 255
Data 253 , 249 , 241 , 225 , 193 , 129 , 1 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 239 , 255 , 239 , 255 , 255
Data 117 , 189 , 121 , 125 , 215 , 93 , 173 , 113 , 109 , 109 , 147 , 149 , 215 , 215 , 125 , 127
Data 109 , 119 , 109 , 125 , 125 , 109 , 111 , 125 , 239 , 125 , 253 , 239 , 253 , 191 , 223 , 125
Data 111 , 125 , 111 , 109 , 127 , 253 , 251 , 253 , 215 , 239 , 117 , 0 , 255 , 125 , 255 , 255 , 255
Data 213 , 237 , 221 , 221 , 213 , 129 , 181 , 239 , 221 , 253 , 247 , 125 , 223 , 239 , 221 , 215
Data 215 , 239 , 213 , 3 , 253 , 251 , 253 , 235 , 245 , 217

Kol3:                                                       'tablica dla kolumn 3 wyswietlaczy led
Data 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 129 , 129 , 129 , 129 , 129 , 129 , 129 , 255
Data 253 , 249 , 241 , 225 , 193 , 129 , 1 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 131 , 255 , 239 , 255 , 255
Data 109 , 0 , 117 , 93 , 183 , 93 , 109 , 111 , 109 , 109 , 147 , 147 , 187 , 215 , 187 , 117
Data 97 , 119 , 109 , 125 , 125 , 109 , 111 , 109 , 239 , 0 , 125 , 215 , 253 , 207 , 239 , 125
Data 111 , 117 , 103 , 109 , 0 , 253 , 253 , 227 , 239 , 241 , 109 , 125 , 255 , 125 , 255 , 255 , 255
Data 213 , 221 , 221 , 221 , 213 , 111 , 181 , 223 , 65 , 221 , 235 , 0 , 231 , 223 , 221 , 215
Data 215 , 223 , 213 , 221 , 253 , 253 , 243 , 247 , 245 , 213

Kol4:                                                       'tablica dla kolumn 4 wyswietlaczy led
Data 255 , 253 , 251 , 247 , 239 , 223 , 191 , 127 , 253 , 251 , 247 , 239 , 223 , 191 , 255 , 255
Data 253 , 249 , 241 , 225 , 193 , 129 , 1 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 239 , 255 , 239 , 255 , 255
Data 93 , 253 , 109 , 45 , 0 , 93 , 109 , 95 , 109 , 107 , 255 , 255 , 125 , 215 , 215 , 111
Data 125 , 119 , 109 , 125 , 187 , 109 , 111 , 109 , 239 , 125 , 3 , 187 , 253 , 191 , 247 , 125
Data 111 , 123 , 107 , 109 , 127 , 253 , 251 , 253 , 215 , 239 , 93 , 125 , 255 , 0 , 255 , 255 , 255
Data 213 , 221 , 221 , 237 , 213 , 127 , 181 , 223 , 253 , 67 , 221 , 253 , 223 , 223 , 221 , 215
Data 231 , 223 , 213 , 253 , 251 , 251 , 253 , 235 , 245 , 205

Kol5:                                                       'tablica dla kolumn 5 wyswietlaczy led
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 253 , 249 , 241 , 225 , 193 , 129 , 1 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 239 , 255 , 239 , 255 , 255
Data 131 , 255 , 157 , 115 , 247 , 99 , 243 , 63 , 147 , 135 , 255 , 255 , 255 , 215 , 239 , 159
Data 131 , 129 , 147 , 187 , 199 , 125 , 127 , 161 , 0 , 255 , 127 , 125 , 253 , 0 , 0 , 131
Data 159 , 133 , 157 , 115 , 127 , 3 , 7 , 3 , 57 , 31 , 61 , 255 , 255 , 255 , 255 , 255 , 255
Data 225 , 227 , 251 , 0 , 231 , 191 , 131 , 225 , 255 , 255 , 255 , 255 , 225 , 225 , 227 , 239
Data 193 , 239 , 251 , 251 , 193 , 199 , 195 , 221 , 195 , 221