'Wyswietlacz LCD PC
'Marcin Wiazania
'email: mwiazani@poczta.fm

'*************************************************************************************
'* Ustawienia bezpiecznikow w BASCOM: (potrzebne do poprawnej pracy mikrokontrolera) *
'* Lockbits:                                                                         *
'*  - Lockbit 65: 11                                                                 *
'*  - Lockbit 43: 11                                                                 *
'*  - Lockbit 21: 11                                                                 *
'* Fusebits:                                                                         *
'*  - Fusebit C: 0 (BODLEVEL 4.0V)                                                   *
'*  - Fusebit B: 0 (BODEN enabled)                                                   *
'*  - Fusebit KL: 10 (6 CK, 64 mS delay)                                             *
'*  - Fusebit A987: 1111 (1111 external XTAL)                                        *
'* Fusebits High                                                                     *
'*  - Fusebit M: 0 (PIN PC6 is IO pin) Ustawic na 1 gdy bedzie jeszcze programowany  *
'*  - Fusebit J: 1 (WDT enabled by WDTCR)                                            *
'*  - Fusebit I: 0 (SPI enabled)                                                     *
'*  - Fusebit H: 1 (CKOPT 1)                                                         *
'*  - Fusebit G: 1 (Erase EEPROM when chip erase)                                    *
'*  - Fusebit FE: 00 (1024 words boot size, C00)                                     *
'*  - Fusebit D: 1 (Reset vector is $0000)                                           *
'*************************************************************************************

$regfile = "m8def.dat"
$crystal = 8000000
$baud = 19200
Config Watchdog = 2048
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5
Config Serialin = Buffered , Size = 255                     'bufor przychodzacych danych z RS232
Config Timer0 = Timer , Prescale = 1024
Config Rc5 = Pind.2 , Timer = 2
Config Int0 = Falling
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Disconnect , Prescale = 8
Config Pinc.6 = Output
Config Pind.3 = Output
Config Pind.4 = Output
Config Pind.5 = Output
Config Pind.6 = Output
Config Pinb.5 = Input
Config Pinb.4 = Input
Config Pinb.3 = Input
Config Pinb.2 = Input
Config Pinb.0 = Input
Config Pind.7 = Input
Config Lcd = 20 * 4
Stop Watchdog

Declare Sub Pob_znak                                        'Procedura pobrania znaku przeslanego przez RS232
Declare Sub Prog                                            'Procedura wejscia w tryb konfiguracji LCD PC
Declare Sub Lad_predk                                       'Procedura ladowania wybranej predkosci RS232
Declare Sub Lad_lcd                                         'Procedura ladowania rodzaju LCD
On Timer0 Obsl_klaw                                         'Przerwania obslugi klawiatury
On Int0 Rc5                                                 'Przerwanie obslugi pilota RC5

Dim Znak As Byte                                            'przechowuje odebrany znak z RS232
Dim I As Byte                                               'zmienna dla petli for
Dim Kol As Byte                                             'numer kolumny wyswietlacza LCD
Dim Wiersz As Byte                                          'numer wiersza wyswietlacza LCD
Dim Il_zn As Byte
Dim Podsw As Byte                                           'flaga podswietlenia on/off
Dim Minut As Byte                                           'czas poswietlenia w minutach
Dim Nr_zn As Byte                                           'numer znaku
Dim Il_wierszy As Byte                                      'ilosc wierszy dla wybranego rodzaju wyswietlacza
Dim Il_znakow As Byte                                       'ilosc znakow dla wybranego rodzaju wyswietlacza
Dim Il_kol As Byte                                          'ilosc kolumn dla wybranego wyswietlacza
Dim Wr2 As Byte                                             'zmienna pomocnicza dla 2 wiersza
Dim Wr3 As Byte                                             'zmienna pomocnicza dla 3 wiersza
Dim Menu As Byte                                            'zmienna przechowujaca dane dla po wejsciu do menu
Dim Predkosc As Byte                                        'wybrana predkosc transmisji rs232
Dim Rodz_lcd As Byte                                        'wybrany rodzaj LCD
Dim Key As Byte                                             'przechowuje kod nacisnietego klawisza takze dlawisza pilota rc5
Dim Zezw_kl As Bit                                          'flaga zezwolenia na obsluge klawiszy
Dim Temp_kl1 As Byte                                        'zmienna pomocnicza dla klawiatury
Dim Temp_kl2 As Byte                                        'zmienna pomocnicza dla klawiatury
Dim Buf_kl(5) As Byte                                       'bufor klawiatury
Dim Ind As Byte                                             'zmienna indeksowa dla bufora klawiatury
Dim Flag_buf As Bit                                         'flaga uzycia bufora klawiatury
Dim Address As Byte , Command As Byte                       'zmienna dla polecenia odczytu kodu rc5
Dim Flag_rc As Bit                                          'flaga zezwolenia odczytu kodu rc5
Dim Licz As Byte                                            'zmienna licznikowa
Dim Sek As Word                                             'zmienna odliczenia 1 minuty
Dim Adr_rc5 As Byte                                         'zmienna przechowujaca adres pilota rc5

O1 Alias Portc.6                                            'wyjscia O1 - O5
O2 Alias Portd.3
O3 Alias Portd.4
O4 Alias Portd.5
O5 Alias Portd.6
S1 Alias Pinb.5                                             'Przycisk S1 - S6
S2 Alias Pind.7
S3 Alias Pinb.4
S4 Alias Pinb.3
S5 Alias Pinb.0
S6 Alias Pinb.2

Set Portb.5
Set Portd.7
Set Portb.4
Set Portb.3
Set Portb.0
Set Portb.2
Set O1
Set O2
Set O3
Set O4
Set O5

Nr_zn = 1
Predkosc = 2
Rodz_lcd = 1
Adr_rc5 = 0
Key = 0
Ind = 0
Flag_buf = 1
Licz = 0
Podsw = 255
Pwm1a = 0
Cursor Off                                                  'konfiguracja LCD
Cursor Noblink
Readeeprom Menu , 1                                         'odczyt z eeprom wartosci

If Menu <> 5 Then                                           'Jezeli odczytana wartosc <>5 to
  Menu = 5                                                  'pierwsze wlaczenie LCD PC to
  Writeeeprom Menu , 1                                      'zapisze do eeprom wartosci poczatkowe
  Writeeeprom Predkosc , 2                                  'ktore beda brane pod uwage podczas
  Writeeeprom Rodz_lcd , 3                                  'nastepnych uruchomien PC LCD
  Writeeeprom Adr_rc5 , 4
End If

Readeeprom Predkosc , 2                                     'Odczyt danych dla zmiennych z eeprom
Call Lad_predk
Readeeprom Rodz_lcd , 3
Call Lad_lcd
Readeeprom Adr_rc5 , 4

Enable Interrupts
Enable Int0
Enable Timer0
Start Timer0

Do                                                          'Petla glowna programu
  Call Prog
  Call Pob_znak                                             'pobiera znak
  If Znak = 254 Then                                        'jezeli znak ma wartosc 256 to nadawana jest komenda
    Call Pob_znak
    If Znak = 65 Then                                       'nie uzywaj bufora klawiatury
      Set Flag_buf
    End If
    If Znak = 79 Then                                       'uzywaj bufora klawiatury
      Reset Flag_buf
    End If
    If Znak = 69 Then                                       'zeruj bufor klawiatury
      Ind = 0
      For I = 1 To 5
        Buf_kl(i) = 0
      Next I
    End If
    If Znak = 126 Then                                      'nie uzywana komenda
      Call Pob_znak
    End If
    If Znak = 38 Then                                       'komenda odpytujaca stan klawiszy przechowywanych w buforze
      If Ind = 0 And Key = 0 Then                           'jezeli brak kodow w buforze oraz brak nacisnietego klawisza
        Print Chr(0);                                       'wyslij 0
      Else
        Print Chr(key);                                     'przeciwnym wypadku wyslij stan klawisza
      End If
      If Ind = 1 Then                                       'Jezeli w bufor zawiera 1 kod klawisza
        Temp_kl2 = Buf_kl(ind)
        Buf_kl(ind) = 0
        Decr Ind                                            'zmiejsz wskaznik bufora
        Print Chr(temp_kl2);                                'wysyla kod klawisza
      End If
      If Ind > 1 Then                                       'jezeli bufor zawiera wiecej niz 1 klawisz to
        Temp_kl2 = Buf_kl(ind)                              'ustaw najstarszy bit kodu klawisza
        Buf_kl(ind) = 0
        Set Temp_kl2.7
        Decr Ind
        Print Chr(temp_kl2);                                'wysyla kod klawisza z ustawionym najstarszym bitem
      End If
    End If
    If Znak = 88 Then                                       'wyczysc lcd
      Cls
      Kol = 1                                               'wartosc poczatkowe
      Wiersz = 1
      Nr_zn = 1
    End If
    If Znak = 74 Then                                       'kursor - on
      Cursor On
    End If
    If Znak = 75 Then                                       'kursor - off
      Cursor Off
    End If
    If Znak = 76 Then                                       'kursor o jedna pozycje w lewo
      Shiftcursor Left
      If Nr_zn > 1 Then
        Decr Nr_zn
      End If
    End If
    If Znak = 77 Then                                       'kursor o jedna pozyje w prawo
      Shiftcursor Right
      Incr Nr_zn
    End If
    If Znak = 83 Then                                       'migajacy kursor - on
      Cursor Blink
    End If
    If Znak = 84 Then                                       ' migajacy kursor - off
      Cursor Noblink
    End If
    If Znak = 72 Then                                       'kursor na poczatek wyswietlacza
      Home
      Kol = 1
      Wiersz = 1
      Nr_zn = 1
    End If
    If Znak = 71 Then                                       'pozycja kursora
      Call Pob_znak
      Kol = Znak
      Call Pob_znak
      Wiersz = Znak
      Nr_zn = 1
      Locate Wiersz , Kol
      Select Case Wiersz                                    'odpowiednie wyliczenie zmiennej nr_zn
        Case 1 : Nr_zn = Kol
        Case 2 : Nr_zn = Kol + Il_kol
        Case 3 : Nr_zn = Kol + Wr2
        Case 4 : Nr_zn = Kol + Wr3
      End Select
    End If
    If Znak = 78 Then                                       'definicja wlasnych znakow
      Call Pob_znak
      Znak = Znak * 8
      Znak = Znak + 64
      lds r24,{znak}
      Rcall _Lcd_control                                    'zaladuj adres
      For I = 1 To 8
        Call Pob_znak
        Lds R24,{znak}
        rcall _Write_lcd                                    'zaladuj wlasny znak
      Next I
    End If
    If Znak = 80 Then                                       'poziom poswietlenia
      Call Pob_znak
      Podsw = Znak
      Pwm1a = Podsw
    End If
    If Znak = 70 Then                                       'podswietlenie off
      Pwm1a = 0
    End If
    If Znak = 66 Then                                       'podswietlenie on
      Call Pob_znak
      Minut = Znak                                          'czas podswietlenia, gdy 0 to podswietlenie wlaczone bez odliczania czasu
      Sek = 1831
      Pwm1a = Podsw
    End If
    If Znak = 86 Then                                       'Wylacz odpowiednie wyjscia O1 - O5
      Call Pob_znak
      Select Case Znak
        Case 1 : Set O1
        Case 2 : Set O2
        Case 3 : Set O3
        Case 4 : Set O4
        Case 5 : Set O5
      End Select
    End If
    If Znak = 87 Then                                       'Wlacz odpowiednie wyjscia O1 = O5
      Call Pob_znak
      Select Case Znak
        Case 1 : Reset O1
        Case 2 : Reset O2
        Case 3 : Reset O3
        Case 4 : Reset O4
        Case 5 : Reset O5
      End Select
    End If
    Znak = 0
  Else
    If Nr_zn <= Il_znakow Then
      Lcd Chr(znak)                                         'wyswietla znak na pozycji okreslonej przez zmienna nr_zn
      Znak = 0
      If Nr_zn = Il_kol Then                                'Przejscie do 2 linii
        Locate 2 , 1
      End If
      If Nr_zn = Wr2 Then                                   'Przejscie do 3 linii
        Locate 3 , 1
      End If
      If Nr_zn = Wr3 Then                                   'Przejscie do 4 linii
        Locate 4 , 1
      End If
      Incr Nr_zn                                            'zwieksz numer znaku
    End If
  End If
Loop                                                        'Koniec petli glownej programu
End

Sub Prog
  If S1 = 0 And S3 = 0 And S4 = 0 Then                      'Wejscie w konfiguracyjne menu
    Disable Timer0
    Baud = 9600                                             'predkosc transmisji dla trybu menu
    Do
      Print
      Print "LCD PC - RS232"
      Print "MENU:"
      Print
      Print "1 - Predkosc RS232"
      Print "2 - Konfiguracja LCD"
      Print "3 - Adres RC5"
      Print "4 - Wyjscie z MENU"
      Input ">" , Menu Noecho
      If Menu = 1 Then                                      'gdy wyslano wartosc 1
        Do                                                  'konfiguracja predkosci RS232
          Menu = 0
          Print "Predkosc RS232:"
          Print "1 - 4800";
          If Predkosc = 1 Then
            Print " *"
          Else
            Print
          End If
          Print "2 - 9600";
          If Predkosc = 2 Then
            Print " *"
          Else
            Print
          End If
          Print "3 - 19200";
          If Predkosc = 3 Then
            Print " *"
          Else
            Print
          End If
          Print "4 - Powrot"
          Input ">" , Menu Noecho
          If Menu < 4 Then
            Predkosc = Menu
          End If
        Loop Until Menu = 4
        Menu = 0
        Writeeeprom Predkosc , 2
      End If
      If Menu = 2 Then                                      'gdy wyslano wartosc 2
        Do                                                  'konfiguracja LCD
          Menu = 0
          Print "Konfiguracja LCD:"
          Print "1 - 16x2";
          If Rodz_lcd = 1 Then
            Print " *"
          Else
            Print
          End If
          Print "2 - 16x4";
          If Rodz_lcd = 2 Then
            Print " *"
          Else
            Print
          End If
          Print "3 - 20x2";
          If Rodz_lcd = 3 Then
            Print " *"
          Else
            Print
          End If
          Print "4 - 20x4";
          If Rodz_lcd = 4 Then
            Print " *"
          Else
            Print
          End If
          Print "5 - Powrot"
          Input ">" , Menu Noecho
          If Menu < 5 Then
            Rodz_lcd = Menu
          End If
        Loop Until Menu = 5
        Writeeeprom Rodz_lcd , 3
      End If
      If Menu = 3 Then                                      'gdy wyslano wartosc 3
        Do                                                  'Odczyt adresu pilota rc5
          Menu = 0
          Print "Adres RC5:"
          Print "Nacisnij przycisk na pilocie oraz klawisz ENTER!!!"
          Print "Adres: " ; Adr_rc5
          Print "1 - Powrot"
          Input ">" , Menu Noecho
          If Flag_rc = 1 And Address < 100 Then
            Adr_rc5 = Address
            Reset Flag_rc
            Enable Int0
          End If
        Loop Until Menu = 1
        Writeeeprom Adr_rc5 , 4
      End If
    Loop Until Menu = 4                                     'koniec menu
    Print "Koniec MENU"
    Print
    Call Lad_predk
    Call Lad_lcd
    Enable Timer0
  End If
End Sub

Sub Lad_lcd                                                 'konfiguracja zmiennych dla lcd w zaleznosci od wybranego lcd
  Select Case Rodz_lcd
    Case 1 :
      Il_wierszy = 2
      Il_kol = 16
      Wr2 = Il_kol * 2
      Wr3 = 200
    Case 2 :
      Il_wierszy = 4
      Il_kol = 16
      Wr2 = Il_kol * 2
      Wr3 = Il_kol * 3
    Case 3 :
      Il_wierszy = 2
      Il_kol = 20
      Wr2 = Il_kol * 2
      Wr3 = 200
    Case 4 :
      Il_wierszy = 4
      Il_kol = 20
      Wr2 = Il_kol * 2
      Wr3 = Il_kol * 3
  End Select
  Il_znakow = Il_wierszy * Il_kol                           'obliczenie ilosc mozliwych znakow do wyswietlenia
  Cls
End Sub

Sub Lad_predk                                               'podrogram ladowania wybranej predkosci transmisji
  Select Case Predkosc
    Case 1 : Baud = 4800
    Case 2 : Baud = 9600
    Case 3 : Baud = 19200
  End Select
End Sub

Sub Pob_znak                                                'podprogram pobierajacy oraz czekajacy na znak
  Do
    Call Prog
    If Flag_rc = 0 Then                                     'gdy flaga zezwolenia rc5 wyzerowana to wlacz mozliwosc
      Enable Int0                                           'odczytu kodu z pilota rc5
    End If
    Il_zn = Ischarwaiting()                                 'sprawdza czy sa jeszcze nieodczytane znaki
    Znak = Inkey()                                          'pobiera znak
    If Znak = 0 And Il_zn = 1 Then
      Exit Do                                               'wyjscie z petli do-loop
    End If
  Loop Until Znak > 0                                       'jezeli znak >0 to wyjdz z petli
End Sub

Obsl_klaw:                                                  'przerwanie od timer0 przeznaczone do obslugi klawiatury oraz odmierzania czasu swiecenia wyswietlacza
  Incr Licz
  If Minut > 0 Then                                         'odlicz gdy minut>0
    Decr Sek
    If Sek = 0 Then                                         'gdy sek =0 to odliczono 1 minute
      Sek = 1831
      Decr Minut
      If Minut = 0 Then
        Pwm1a = 0                                           'wylacz podswietlenie
      End If
    End If
  End If
  If Licz = 5 Then                                          'co 5 przerwan timera0 odczytuj kody klawiszy, takze klawiszy pilota rc5
    Licz = 0
    Stop Timer0
    Key = 0
    If Flag_rc = 1 Then                                     'flaga ustawiona gdy odebrano znak z pilota rc5
      If Command < 100 And Address = Adr_rc5 Then
        Key = Command + 71                                  'zapisz do key wartosc klawisza
      End If
      Command = 192
      Reset Flag_rc                                         'zeruj flage zezwolenia na ponowny odczyt kodu klawiszy z pilota rc5
    End If
    If S1 = 0 Then                                          'odczy wartosci przyciskow S1 - S6
      Key = 65
    End If
    If S2 = 0 Then
      Key = 66
    End If
    If S3 = 0 Then
      Key = 67
    End If
    If S4 = 0 Then
      Key = 68
    End If
    If S5 = 0 Then
      Key = 69
    End If
    If S6 = 0 Then
      Key = 70
    End If
    If Temp_kl1 <> Key Then                                 'sprawdzenie czy zostaly puszczone przyciski
      Temp_kl1 = Key
      If Key > 0 Then
        Set Zezw_kl                                         'Jezeli tak to zezwol na wyslanie znaku lub w pisanie go do bufora
      End If
    End If
  End If
  If Flag_buf = 1 And Zezw_kl = 1 Then                      'natychmiastowe wyslanie kodu klawisza poprzez RS232
    Ind = 0
    Reset Zezw_kl                                           'zerowanie flagi zezwolenia na wyslanie znaku
    Print Chr(key);
  End If
  If Flag_buf = 0 And Zezw_kl = 1 Then                      'zapis kodu klawiszy do bufora klawiatury
    If Ind < 5 Then
      Incr Ind
      Buf_kl(ind) = Key
      Reset Zezw_kl                                         'zerowanie flagi zezwolenia na wyslanie znaku
    End If
  End If
  Start Timer0
Return

Rc5:                                                        'przerwanie int0 sluzace do odczytu kodu rc5
  Stop Timer0
  Disable Int0
  Enable Interrupts                                         'wlacz przerwania zezwalajac na obsluge innych
  Getrc5(address , Command)                                 'odczyt kodu rc5
  Command = Command And &B01111111                          'formatuj odczytana komende
  Set Flag_rc                                               'ustaw flagu swiadczaca o odczytaniu kodu rc5
  Start Timer0
  Disable Interrupts
Return