'Modul pomiaru temperatury termostatu
'Ukad slave sieci RS485.
'Predkosc komunikacji 9600 bodw
'Fuse bit A987 ustawione na wartosc 1111 (zewnetrzny rezonator kwarcowy)
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$regfile = "m8def.dat"                                      'informuje kompilator o pliku dyrektyw wykorzystywanego mikrontrolera
$crystal = 8000000                                          'informuje kompilator o czestotliwosci rezonatora kwarcowego
$baud = 9600                                                'informuje kompilator o predkosci transmisji RS232
$framesize = 50                                             'wielkosc ramki
$hwstack = 50                                               'wielkosc stosu sprzetowego
$swstack = 50                                               'wielkosc stosu programowego

Config Pinb.0 = Output                                      'linia pb.0 jako wyjscie
Config Pinb.1 = Input                                       'linia pb.1 jako wejscie
Config Pinb.2 = Input                                       'linia pb.2 jako wejscie
Config Pinb.3 = Input                                       'linia pb.3 jako wejscie
Config Pinb.4 = Input                                       'linia pb.4 jako wejscie
Config Pinb.5 = Input                                       'linia pb.5 jako wejscie
Config Pind.7 = Input                                       'linia pd.7 jako wejscie
Config Pind.2 = Output                                      'linia pd.2 jako wyjscie
Config Adc = Single , Prescaler = Auto , Reference = Avcc   'konfiguracja wewnetrznego przetwornika
Config Serialin = Buffered , Size = 40                      'konfiguracja by interfejs rs232 uzywal przy odbiorze transmisji buforowej (bufor o wielkosci 15 znakow)
Config 1wire = Portc.0                                      'konfiguracja magistrali 1wire
Config Watchdog = 1024                                      'konfiguracja watchoga

Declare Sub Odb_dan();                                      'procedura odbierania danych

Dim Adr As Byte                                             'zmienna adresu modulu
Dim Wart_zm As Word                                         'zmienna przechowujaca wartosc zmierzona przez przetwornik A/C
Dim Temp As Word                                            'zmienna ktora przechowuje obliczona temperature
Dim Zn As String * 1                                        'zmienna przecowujaca odebrany znak z rs232
Dim Adr_s As String * 5                                     'zmienna w ktorej skladany jest w calosc otrzymany adres
Dim Adres As Byte                                           'zmienna ktora przechowuje przekonwertowany na dziesietnie otrzymany adres
Dim Il_zn As Byte                                           'zmienna liczy ilosc otrzymanych znakow przy skladaniu adresu
Dim Temp_pom As Single                                      'zmienna pomiaru temperatury przez LM335
Dim Temp_zm As Integer                                      'przechowuje zmierzona temperature
Dim I As Byte                                               'zmienna licznikowa
Dim Temp_ds(2) As Byte                                      'tablica na wynik pomiaru przez DS18B20
Dim Tmp_ds As Integer                                       'zmienna pomocnicza przy obliczeniu temperatury z DS18B20

Re_de Alias Portd.2                                         'przypisanie aliasu linii pd.2, re_de steruje kierunkiem transmisji konwertera
Zw Alias Pind.7                                             'przypisanie aliasu Zw linii pind.7
Led Alias Portb.0                                           'przypisanie aliasu led linii pb.0

Set Portd.7                                                 'wlaczenie rezystora podcigajacego linii pd.7
Set Portb.1                                                 'wlaczenie rezystora podcigajacego linii pb.1
Set Portb.2                                                 'wlaczenie rezystora podcigajacego linii pb.2
Set Portb.3                                                 'wlaczenie rezystora podcigajacego linii pb.3
Set Portb.4                                                 'wlaczenie rezystora podcigajacego linii pb.4
Set Portb.5                                                 'wlaczenie rezystora podcigajacego linii pb.5
Set Led                                                     'wylaczenie LED

Start Adc                                                   'uruchamia wbudowany przetwornik A/C
Enable Interrupts                                           'odblokowanie globalnych przerwan
Reset Re_de                                                 'przelaczenie konwertera rs485 na odbiornik
Reset Watchdog                                              'zerowanie watchdog
Start Watchdog                                              'start watchdoga

Do                                                          'poczatek petli programu
  Reset Watchdog                                            'zerowanie watchdog
  If Zw = 0 Then                                            'jesli zw=0 to
    Temp = 0                                                'zerowanie temp
    For I = 1 To 10                                         'petla wykonywana 5 razy
      Wart_zm = Getadc(0)                                   'pomiar napiecia na wejciu PC0 mikrokontrolera
      Temp = Temp + Wart_zm                                 'Dodanie Kolejnego Pomiaru
      Reset Watchdog                                        'zerowanie watchdog
      Waitms 50                                             'czekaj 150 ms
      Call Odb_dan                                          'wywolanie procedury odbierania danych
    Next I                                                  'zwieksz o 1 zmienna I
    Temp = Temp / 10                                        'obliczenie sredniej temperatury
    Temp_pom = Temp * 0.48828125                            'obliczenie temperatury
    Temp_zm = Round(temp_pom)                               'zaokraglenie temperatury
    Temp_zm = Temp_zm - 273                                 'przeliczenie Kelwinow na stopnie C
       If Temp_zm > 200 Then                                'jesli zmienna > od 200 to
    Temp_zm = 200                                           'przypisanie zmiennej wartosci 200
    End If
  Else                                                      'w przeciwnym razie
    1wreset                                                 'zerowanie magistrali 1wire
    1wwrite &HCC                                            'przeskoczenie numeru ukladu DS
    1wwrite &H44                                            'start pomiaru
    For I = 1 To 15                                         'petla wykonywana 5 razy
     Reset Watchdog                                         'zerowanie watchdog
     Waitms 50                                              'czekaj 750 ms
      Call Odb_dan                                          'wywolanie procedury odbierania danych
    Next I                                                  'zwieksz o 1 zmienna I
    1wreset                                                 'zerowanie magistrali 1wire
    1wwrite &HCC                                            'przeskoczenie numeru ukladu DS
    1wwrite &HBE                                            'rozkaz odczytu temperatury
    Temp_ds(1) = 1wread(2)                                  'odczyt temperatury
    Tmp_ds = Temp_ds(2)                                     'obliczenie temperatury
    Shift Tmp_ds , Left , 8                                 'dalsze obliczenia
    Tmp_ds = Tmp_ds + Temp_ds(1)                            'dalsze obliczenia
   Temp_zm = Tmp_ds / 16                                    'dalsze obliczenia
 End If
Loop                                                        'koniec glownej petli do-loop
End                                                         'koniec programu

Sub Odb_dan                                                 'procedura odbioru danych
  Reset Watchdog                                            'zerowanie watchdog
  Zn = Inkey()                                              'odczyt znaku z portu rs232
  If Zn = Chr(8) Then                                       'jesli otrzymany znak to BS (backspace - kod ascii 8) to
    Adr_s = ""                                              'czysc zmienna adr_s
    Il_zn = 0                                               'oraz zeruj zmienna il_zn
    Do                                                      'poczatek petli do-loop
      Reset Watchdog                                        'zerowanie watchdog
      Zn = Inkey()                                          'odczyt znaku z portu rs232
      If Zn >= "0" And Zn <= "9" Then                       'jesli otrzynany znak jest cyfra (0..9) to
        Incr Il_zn                                          'zwieksz o jeden il_zn
        Adr_s = Adr_s + Zn                                  'dodaj otrzymany znak cyfry do zmiennej adr_s
      Else                                                  'w przeciwnym razie
        If Zn > Chr(0) Then                                 'jesli otrzymany znak ma kod ascii wiekszy od 0 to
          Exit Do                                           'opusc petle do-loop
        End If
      End If
    Loop                                                    'koniec wewnetrznej petli do-loop
    If Zn = "r" Then                                        'jesli otrzymany znak to "r" oraz
      If Il_zn > 0 And Il_zn < 3 Then                       'jesli il_zn wynosi 1 lub 2 to
        Adres = Val(adr_s)                                  'zamien znakowa wartosc otrzymanego adresu na postac liczbowa i umiesc ja w adres
        Adr = Pinb And &B00111110                           'odczyt adresu modulu
        Shift Adr , Right , 1                               'obliczenie adresu modulu
        Adr = 31 - Adr                                      'dalsze obliczenie adresu modulu
        If Adres = Adr Then                                 'jesli otrzymany adres od mastera rowna sie adresowi tego modulu oraz
          Reset Led                                         'wlaczenie diody LED
          Do                                                'poczatek wewnetrznej petli do-loop
            Reset Watchdog                                  'zerowanie watchdog
            Zn = Inkey()                                    'odczyt znaku z portu rs232
          Loop Until Zn = Chr(13)                           'jesli otrzymany znak to cr - enter (kod ascii 13) to
          Set Re_de                                         'przelaczenie konwertera rs485 na nadajnik
          Waitus 200                                        'czekaj 200 us
          Print Temp_zm                                     'wyslij zmierzona temperature 
          Waitms 1                                          'czekaj 1ms
          Reset Re_de                                       'przelaczenie konwertera rs485 na odbiornik
        End If
      End If
    End If
  End If
  Reset Watchdog                                            'zerowanie watchdog
  Waitms 80                                                 'czekaj 80 ms
  Set Led                                                   'wylaczenie diody LED
End Sub                                                     'koniec procedury